#!/bin/sh

# switch to 'debian'-branch
git checkout debian || exit 1

# merge in 'master'
git merge master || exit 1

# update debian/changelog
dch --force-distribution -D iem -i "New upstream"
dch --force-distribution -D iem -r

# finalize git repo
git commit debian/changelog -m "Ready for upload" || exit 1

# create the package
dpkg-buildpackage -rfakeroot || exit 1

# create a git-tag
gbp buildpackage --git-ignore-new --git-tag-only

# go back to master branch
git checkout master
